<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="分组ID" prop="groupId">
        <el-select v-model="formData.groupId">
          <el-option
            v-for="item in groupList"
            :key="item.groupName"
            :label="item.groupName"
            :value="item.id"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="回复内容">
        <el-input
          v-model="formData.content"
          :autosize="{ minRows: 2, maxRows: 8 }"
          type="textarea"
          placeholder="Please input"
        />
      </el-form-item>
      <el-form-item label="是否需要翻译" prop="needTranslation">
        <el-radio-group v-model="formData.needTranslation">
          <el-radio
            v-for="dict in getBoolDictOptions(DICT_TYPE.INFRA_BOOLEAN_STRING)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { DICT_TYPE, getBoolDictOptions } from '@/utils/dict'
import * as QuickRepliesApi from '@/api/message/quickReplies'
import * as QuickGroupApi from '@/api/message/quickGroup'
import { onMounted } from 'vue'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  groupId: undefined,
  content: undefined,
  needTranslation: undefined
})
const groupList = ref([])

const getGroupList = async () => {
  try {
    const params = {
      pageNo: 1,
      pageSize: 20
    }
    const data = await QuickGroupApi.getQuickGroupPage(params)
    groupList.value = data.list
  } finally {
  }
}

const formRules = reactive({
  groupId: [{ required: true, message: '分组ID不能为空', trigger: 'blur' }],
  content: [{ required: true, message: '回复内容不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await QuickRepliesApi.getQuickReplies(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as QuickRepliesApi.QuickRepliesVO
    if (formType.value === 'create') {
      await QuickRepliesApi.createQuickReplies(data)
      message.success(t('common.createSuccess'))
    } else {
      await QuickRepliesApi.updateQuickReplies(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    groupId: undefined,
    content: undefined,
    needTranslation: undefined
  }
  formRef.value?.resetFields()
}

onMounted(async () => {
  await getGroupList()
})
</script>
